
; granular texture melody instrument,
; reads grains from soundfile,
; percieved pitch controlled by transposition of wave inside grain


; main envelope
iatkT		= 1.2
idecT		= 1
isusL		= 0.6
irelT		= 1.9
amp		madsr	iatkT, idecT, isusL, isusL
amp		= amp * iamp

; grain source
ifna		= giZyneOct
;ifna		= giZyne100110
isndfq		= (sr/ftlen(ifna))		; calculation of orig speed
ilength		= (ftlen(ifna) / sr)		; table length in seconds
isndlen		= nsamp(ifna)/sr		; actual sound length (secs) loaded into table
isndlen		= isndlen * 0.99		; try to avoid empty grains at end of sound

; time pointer
kspeed		= 0.3*isndfq
kphs		phasor	kspeed
kphsDevAmt	= 0.002
iphsDev_rpw	= -0.66
kphsDev		rnd31	kphsDevAmt, iphsDev_rpw
kphs		= kphs + kphsDev
kphs		= kphs * (isndlen/ilength) 	; scale kphs so that it points only to the part of the table actually used to store audio


; fund, grain freq
ifund		= 34
kfund		= ifund
ifujitAmt 	= 0.15			; grain freq jitter amount
kfuJit		jitter	ifund*ifujitAmt, 5, 12
kfund		= kfund + kfuJit

; formant, grain transpose
kform		= semitone(iNote-60) * isndfq	; 0 semitones is orig pitch
koct		= 0
kband		= 0.05 * kfund
kdur		= 3/kfund
kris		= 30*(kdur/100)
kdec		= 30*(kdur/100)

; various, normally not touched
iolaps		= 30
ifnb		= giSigmoRise
itotdur		= 60000
igliss		= 0

a1		fof2	amp, kfund, kform, koct, kband, kris, kdur, kdec, iolaps, ifna, ifnb, itotdur, kphs, igliss
